import java.io.*;
import java.sql.*;
import javax.servlet.*;
import javax.servlet.http.*; 

/*=====================================================================
Servletti Nuottiarkiston etusivun generoimiseen.
Luokka kokoaa etusivun luokan Etusivutekstit tarjoamista palasista ja
kytt luokan Html palveluja. 

kirjoittanut: Ahti Syreeni 
pvm:          23.4.2001
=====================================================================*/
public class Etusivu extends HttpServlet{
  public void service(HttpServletRequest req, HttpServletResponse res) 
                      throws ServletException, IOException{
    /**Metodi generoi etusivun. Jos kyttj on kirjoittautunut sisn, 
       generoidaan rekistereityneiden sivu, muuten normaali*/
 
    ServletOutputStream palaute;  
    res.setContentType("text/html");
    palaute= res.getOutputStream();        
    boolean rekisteroitunut=false;
    Cookie[] piparit=req.getCookies();

    //tutkitaan, onko rekisteroitynyt kayttaja
    for(int i=0;i<piparit.length;i++){
      if(piparit[i].getName().equals("nuottiarkisto")){
         if(!(piparit[i].getValue()==null))
           rekisteroitunut=true;
      }
    }
    palaute.println(Etusivutekstit.aluste()); //sivun perusosat
    palaute.println(Etusivutekstit.otsikko());

    if(rekisteroitunut){ //generoidaan eri sivut rekistereityneille
      palaute.println(Etusivutekstit.rekEsittely());
      palaute.println(Etusivutekstit.rekLinkit());
    }
    else{
      palaute.println(Etusivutekstit.esittely());
    }

    //luodaan yhteys tietokantaan
    Connection yhteys=null;
    yhteys= Tietokanta.luoYhteys();
    if (yhteys==null) {
      palaute.println(Virheilmoitukset.tkYhteysvirhe());
      return;
    }

    //haetaan aihepiirien nimet tietokannasta

    Statement stmt = null;
    ResultSet hakutulos = null; 
    String[] tulostaulukko; 

    try { 
      stmt = yhteys.createStatement(); 
      hakutulos = stmt.executeQuery("SELECT DISTINCT nimi FROM "+
                                       "aihepiiri ORDER BY nimi");  

      tulostaulukko=new String[hakutulos.getFetchSize()];
      
      for(int i=0; i<hakutulos.getFetchSize();i++)
        if(hakutulos.next())
          tulostaulukko[i]=hakutulos.getString(1);   

      //generoidaan hakupalvelu kyselyst saaduilla aihepiireill

      palaute.println(Etusivutekstit.hakulomake(tulostaulukko));
      if(!rekisteroitunut)
        palaute.println(Etusivutekstit.login());
      palaute.println(Etusivutekstit.ohjeet());
      palaute.println(Html.lopetus());
    }catch (SQLException e){
      palaute.println(Virheilmoitukset.SQLVirhe(e.getMessage())); 
    }finally{
      try {
        if (hakutulos!=null) hakutulos.close(); 
        if (stmt!=null) stmt.close(); 
        Tietokanta.suljeYhteys(yhteys);
      } catch(SQLException e) {}
    }     
  }
} 
