import java.io.*;
import java.sql.*;
import javax.servlet.*;
import javax.servlet.http.*;
import java.util.Vector;
/*=====================================================================
Kirjastoluokka Nuottiarkiston haun suorittamiseen.
Luokka kokoaa hakusivun luokan Hakutulostekstit tarjoamista palasista ja
kytt luokan Html palveluja. 

kirjoittanut: Ahti Syreeni 
pvm:          23.4.2001
=====================================================================*/
public class Haku extends HttpServlet{
  public void service(HttpServletRequest req, HttpServletResponse res) 
                      throws ServletException, IOException{
    /**Suorittaa nuotistohaun annetuilla perusteilla*/
    ServletOutputStream palaute;  
    res.setContentType("text/html");
    palaute= res.getOutputStream();        
    boolean rekisteroitunut=false;
    Cookie[] piparit=req.getCookies();

    //tutkitaan, onko rekisteroitynyt kayttaja
    for(int i=0;i<piparit.length;i++){
      if(piparit[i].getName().equals("nuottiarkisto")){
         if(!(piparit[i].getValue()==null))
           rekisteroitunut=true;
      }
    }

    //laaditaan annetuista parametreista SQL-kysely
    String kysely="";
    String parametri=null;
    
    //listn hakusanaehto kyselyyn, jos valittu
    if(!(req.getParameter("vhakusana")==null)){    //turhaan ruksittu??
      if(!(req.getParameter("hakusana").equals(""))){ 
        parametri=req.getParameter("hakusana");
        //etsitn hakusanaa kaikista sarakkeista
        kysely+="AND ((UPPER(sEtunimi) like '%"+parametri.toUpperCase()+
                                                              "%') OR "+
	            "    (UPPER(sSukunimi) like '%"+parametri.toUpperCase()+
                                                            "%') OR "+
	            "    (UPPER(tNimi) like '%"+parametri.toUpperCase()+
                                                        "%') OR "+
              "   	(UPPER(URLosoite) like '%"+parametri.toUpperCase()+
                                                             "%') OR "+
	            "    (UPPER(lisatiedot) like '%"+parametri.toUpperCase()+
                                                             "%') OR "+
	            "    (tunnistenumero IN  "+
		          "      (select teosnumero from aiheyhteys, aihepiiri "+
              "      where "+
		          "      aiheviite=aihenumero AND UPPER(nimi) like "+ 
                     "'%"+parametri.toUpperCase()+"%')))"; 
      }
    }
    //listn teoksen nimi hakuehdoksi, jos valittu
    if(!(req.getParameter("vteosnimi")==null)){
      if(!(req.getParameter("teosnimi").equals(""))){
        parametri=req.getParameter("teosnimi");
        kysely+= " AND (UPPER(tNimi) like '"+parametri.toUpperCase()+"%')";
      }
    }
    //listn teoksen sveltj hakuehdoksi, jos valittu
    if(!(req.getParameter("saveltaja")==null)){
      if(!(req.getParameter("etunimi").equals(""))){
        parametri=req.getParameter("etunimi");
        kysely+= " AND (UPPER(sEtunimi) like '"+parametri.toUpperCase()+
                                                                  "%')"; 
      }
      if(!(req.getParameter("sukunimi").equals(""))){
 
        parametri=req.getParameter("sukunimi");
        kysely+= " AND (UPPER(sSukunimi) like '"+parametri.toUpperCase()+
                                                                   "%')"; 
      }
    } 
    if(!(req.getParameter("vvuosi")==null)){
      //svellysvuosi, tasan, ennen vai jlkeen?
      if(!(req.getParameter("svuosi").equals(""))){
        //tarkistetaan numeroarvon kelpoisuus
        try{
          Integer.parseInt(req.getParameter("svuosi"));
        }catch(Exception e){
          palaute.println(Virheilmoitukset.eiNumero());
          return;
        }
        if(req.getParameter("svuositarkkuus").equals("tasan"))
          parametri="=";
	      else
        if(req.getParameter("svuositarkkuus").equals("jalkeen"))
          parametri=">";
	      else
        if(req.getParameter("svuositarkkuus").equals("ennen"))
          parametri="<";
	      else{
          palaute.println(Html.aluste("KoodiVirhe"));
          palaute.println(Html.lopetus());
        }          
        kysely+= " AND (savellysvuosi "+parametri;
        parametri= req.getParameter("svuosi");
        kysely+=" "+parametri+")"; 
      }
    }
    if(!(req.getParameter("vaihepiiri")==null)){
      parametri= req.getParameter("aihepiiri");
      kysely+=" AND (tunnistenumero IN "+
		                  "(select teosnumero from aiheyhteys, aihepiiri "+
                      " where aiheviite=aihenumero AND nimi like "+
                      "'%"+parametri+"'))";
    }    
    if(!(req.getParameter("vuutuudet")==null)){
      try{
        parametri=req.getParameter("uutuudet").substring(0,1);
        parametri.trim();
        int paiva= Integer.parseInt(parametri) * 30; //muunnetaan valittu 
                                                     //kuukausi paivaksi 
        kysely+= " AND (lisayspaiva > (sysdate-"+paiva+"))";     
      }catch(Exception e){
       palaute.println(Virheilmoitukset.SQLVirhe(e.getMessage()));
       return;

      }
    }
    //jos ei mitn valittu, ei kannata tehd tyhj kysely
    if(kysely.equals("")){
      res.sendRedirect("Etusivu");
      return;
    }
    //liitetn kyselyyn varsinaiset SQL-elementit
	  kysely="select distinct sSukunimi, sEtunimi, tNimi, savellysvuosi,"+
           " koko, URLosoite, lisatiedot, lisayspaiva from teos, "+
           "saveltaja where (saveltaja=saveltajanumero) "+kysely;

    kysely=kysely+" ORDER BY sSukunimi, sEtunimi, tNimi";

    //luodaan yhteys tietokantaan ja suoritetaan saatu kysely
    Connection yhteys=null;
    yhteys= Tietokanta.luoYhteys();
    if (yhteys==null) {
      palaute.println(Virheilmoitukset.tkYhteysvirhe());
      return;
    }
    Statement stmt = null;
    ResultSet hakutulos = null;  
    Vector tulosvektori=new Vector(); //listiedot talteen
    try { 
      stmt = yhteys.createStatement(); 
      hakutulos = stmt.executeQuery(kysely);  

      palaute.println(Hakutulostekstit.alkutekstit());
      palaute.println(Hakutulostekstit.linkit(rekisteroitunut)); 
      palaute.println(Hakutulostekstit.taulukko(true)); 
      palaute.println(Hakutulostekstit.sarakenimet());

      String apu;
      int laskuri=0;
      while(hakutulos.next()){
        //tulostetaan hakutulostaulukon rivit
        palaute.println(Hakutulostekstit.tulosrivi(
                                         hakutulos.getString(1),        
                                         hakutulos.getString(2),        
                                         hakutulos.getString(3),        
                                         hakutulos.getString(4),        
                                         hakutulos.getString(5),        
                                         hakutulos.getString(6),        
                                         laskuri));
        //sstetn tiedot listieto-osioita varten
        //ensin estetn null-nimien psy tulosteeseen
        //pakko tehd vaikeasti, jotta ei tule NullPointer-poikkeusta
        apu=hakutulos.getString(1);
        if(apu==null)
          apu="-";           
        else
          if(apu.equals("null"))
            apu="-";           
        if(!(hakutulos.getString(2)==null)){
           if(hakutulos.getString(2).equals("null"))  
             apu+=",";
           else
             apu+=", "+hakutulos.getString(2);
        }
        tulosvektori.addElement(apu+": "+hakutulos.getString(3));
        tulosvektori.addElement(hakutulos.getString(7));
        tulosvektori.addElement(hakutulos.getString(8));
        laskuri++;
      }
    palaute.println("  "+Html.taulukkolopetus());
    palaute.println(Hakutulostekstit.linkit(rekisteroitunut)); 

    laskuri=0;
    for(int i=0;i+2<tulosvektori.size();i+=3){
       //tulostetaan listiedot
       palaute.println(Hakutulostekstit.lisatiedot(
                        (String)tulosvektori.elementAt(i),
                        (String)tulosvektori.elementAt(i+1),
                        (String)tulosvektori.elementAt(i+2),
                        laskuri));
       laskuri++;
    }
    palaute.println(Hakutulostekstit.linkit(rekisteroitunut)); 
    palaute.println(Html.lopetus());
    }catch (SQLException e){
      //hakuehdossa virheit, koska vri merkkej (=hipsuja) annettu
      palaute.println(Virheilmoitukset.kielletytMerkit());
    }finally{
      try {
        if (hakutulos!=null) hakutulos.close(); 
        if (stmt!=null) stmt.close(); 
        Tietokanta.suljeYhteys(yhteys);
      } catch(SQLException e) {}
    }     
  }
} 
