/*=====================================================================
Kirjastoluokka html-rakenteiden tuottamiseen. 

kirjoittanut: Ahti Syreeni 
pvm:          23.4.2001
=====================================================================*/
public class Html{
  private static final String dokumenttityyppi=
    "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0//FI\">";
  //*******************************************************************
  public static String aluste(String sivun_otsikko){
    /**palauttaa html-sivun alusteen ilman taustakuvaa */
    String palaute;
    palaute=dokumenttityyppi+"\n"+
      "<html>\n"+
      "<head>\n"+
      "  <title>"+sivun_otsikko+"</title>\n"+
      "</head>\n"+
      "<body>\n";
    return palaute;
  }
  //-------------------------------------------------------------------
  public static String aluste(String sivun_otsikko, String tausta){
    /**palauttaa html-sivun alusteen taustakuvalla */
    String palaute;
    palaute=dokumenttityyppi+"\n"+
      "<html>\n"+
      "<head>\n"+
      "  <title>"+sivun_otsikko+"</title>\n"+
      "</head>\n"+
      "<body background=\""+tausta+"\">\n";
    return palaute;
  }  
  //-------------------------------------------------------------------
  public static String lopetus(){
    /**palauttaa html-sivun lopetuksen */
    return  "</body>\n"+"<html>";
  }
  //-------------------------------------------------------------------
  public static String otsikkokuva(String teksti, String kuva){
    /**palauttaa html-kuvan ja vaihtoehtotekstin */
    return   "<center><img src=\""+kuva+"\" alt=\""+
              teksti+"\"></center>\n";
  }
  //-------------------------------------------------------------------
  public static String otsikko(String otsikko, int koko){
		/**palauttaa annetun otsikon annetulla koolla */
		if(koko>9)
      koko=9;
		if(koko<1)
      koko=1;
			return "<h"+koko+">"+otsikko+"</h"+koko+">\n\n";
  }
  //-------------------------------------------------------------------
  public static String linkki(String otsikko, String osoite){
    /**palauttaa html-linkin */
		return "<a href=\""+osoite+"\">"+otsikko+"</a>";
  }
  //-------------------------------------------------------------------
  public static String email(String otsikko, String osoite){
    /**palauttaa email-osoitteen */
		return "<a href=\"mailto:"+osoite+"\">"+otsikko+"</a>";
  }
  //-------------------------------------------------------------------
	public static String nimea(String nimettv, String nimi){
    /**nime annetun merkkijonon*/
		return "<a name=\""+nimi+"\">"+nimettv+"</a>\n";
	}
  //-------------------------------------------------------------------
	public static String taulukkoaluste(int reunuskoko, String tyyli){
    /**palauttaa taulukkomrittelyn */
		String palaute;
		if(reunuskoko<0)
			reunuskoko=0;
		if(reunuskoko>3)
			reunuskoko=3;

		if(reunuskoko>0)
			return "<table border="+reunuskoko+" "+tyyli+">\n";
		else   
			return "<table "+tyyli+">\n";
	}
  //-------------------------------------------------------------------
	public static String taulukkolopetus(){
    /**palauttaa taulukon lopputagin */
		return "</table>\n";
	}
  //-------------------------------------------------------------------
	public static String taulukkorivi(boolean aloitus){
    /**palauttaa taulukon rivin */
		if(aloitus)
			return "<tr>\n";
		else
			return "</tr>\n";
	}
  //-------------------------------------------------------------------
	public static String taulukkoalkio(String alkio){
    /**palauttaa taulukon alkion */
		return "<td>"+alkio+"</td>\n";
	}
  //-------------------------------------------------------------------
	public static String kappale(String kappale){
    /**palauttaa kappaleen */
		return "<p>"+kappale+"</p>";
	}	
}
      



 







