import java.io.*;
import java.sql.*;
import javax.servlet.*;
import javax.servlet.http.*; 
/*=====================================================================
Servletti Nuottiarkistoon sisnkirjoittautumiseen

kirjoittanut: Ahti Syreeni 
pvm:          23.4.2001
=====================================================================*/
public class Login extends HttpServlet{
  //*******************************************************************
  private static final String piparinimi="nuottiarkisto"; 
  //*******************************************************************
  public void service(HttpServletRequest req, HttpServletResponse res) 
                      throws ServletException, IOException{
    /**suorittaa sisnkirjoittautumisen*/
    ServletOutputStream palaute;  
    res.setContentType("text/html");
    palaute= res.getOutputStream();        
    String ktunnus=null;

    //luodaan yhteys tietokantaan
    Connection yhteys=null;
    yhteys= Tietokanta.luoYhteys();
    if (yhteys==null) {
      palaute.println(Virheilmoitukset.tkYhteysvirhe());
      return;
    }
    //haetaan kyttjn salasana
    Statement stmt = null;
    ResultSet hakutulos = null; 
    String[] tulostaulukko; 

    try { 
      stmt = yhteys.createStatement(); 
      hakutulos = stmt.executeQuery("SELECT DISTINCT salasana FROM"+ 
                                    "  kayttajatiedot WHERE"+
                                    "  kayttajatunnus='"+
                                       req.getParameter("ktunnus")
                                       +"'");        
      if(hakutulos.next()){
        if(hakutulos.getString("salasana").equals(
           req.getParameter("salasana")) || (hakutulos.getString(
                                          "salasana").equals("null"))){
           ktunnus=req.getParameter("ktunnus");
          try{
            //jos salasana oli oikein, luodaan kyttjlle
            //tunnistepipari
            Cookie tunnistepipari=new Cookie(piparinimi,ktunnus);
            tunnistepipari.setMaxAge(-1); //pipari hvi suljettaessa
                                          //selain
            res.addCookie(tunnistepipari);
            res.sendRedirect("Etusivu");
          }catch(Exception e){
            palaute.println(Virheilmoitukset.eiPipareita());
            return;
          }
        }
        else
          palaute.println(Virheilmoitukset.login());
      }
      else
        palaute.println(Virheilmoitukset.login());
    }catch (SQLException e){
      //salasana tai kyttjtunnus sislsi kiellettyj merkkej
      palaute.println(Virheilmoitukset.kielletytMerkit()); 
    }finally{
      try {
        if (hakutulos!=null) hakutulos.close(); 
        if (stmt!=null) stmt.close(); 
        Tietokanta.suljeYhteys(yhteys);
      } catch(SQLException e) {}
    }
  }
}     
