import java.io.*;
import java.sql.*;
import javax.servlet.*;
import javax.servlet.http.*;

/*=======================================================================
Servletti Nuottijulkaisun lismiseen arkistoon

kirjoittanut: Ahti Syreeni 
pvm:          23.4.2001
=======================================================================*/
public class Nuotinlisays extends HttpServlet{
//***********************************************************************
  //tunniste, jonka perusteella haetaan oikea pipari
  private static final String piparinimi="nuottiarkisto"; 
  private static final String
                            tausta="http//.db.cs.helsinki.fi/u/asyreeni";
//***********************************************************************

  public void service(HttpServletRequest req, HttpServletResponse res) 
                      throws ServletException, IOException {
    /**lis nuottijulkaisun arkistoon*/

    ServletOutputStream palaute;  
    res.setContentType("text/html");
    palaute= res.getOutputStream();        
    String ktunnus=null;
    Cookie[] piparit=req.getCookies();

    //onko pakolliset tiedot, teoksen nimi ja url, annettu...
    if(req.getParameter("nimi").equals("") ||
       req.getParameter("nimi")==null ||
       req.getParameter("url").equals("")){
      palaute.println(Virheilmoitukset.eiNuottitietoja());
      return;
    }

    //tunnistetaan kyttj piparista
    for(int i=0;i<piparit.length;i++){
      if(piparit[i].getName().equals("nuottiarkisto")){
         if(!(piparit[i].getValue()==null))
            ktunnus=piparit[i].getValue();
      }
    }
    
    //onko teoksen saveltaja jo tietokannassa? Laaditaan SQL-kysely!
    String kysely="";

    if(!(req.getParameter("sukunimi").equals("")))
      kysely=" sSukunimi='"+req.getParameter("sukunimi")+"'"; 
    if(!(req.getParameter("etunimi").equals(""))){
        if(!(req.getParameter("sukunimi").equals("")))
          kysely+=" AND ";
      kysely+=" sEtunimi='"+req.getParameter("etunimi")+"'"; 
    }
    kysely="SELECT saveltajanumero FROM saveltaja WHERE "+kysely;

    Connection yhteys=null;
    yhteys= Tietokanta.luoYhteys();
    Statement stmt = null;

      try { 

      stmt = yhteys.createStatement(); 
      ResultSet hakutulos = null; 

      if (yhteys==null) {
        palaute.println(Virheilmoitukset.tkYhteysvirhe());
        if (stmt!=null) stmt.close(); 
        Tietokanta.suljeYhteys(yhteys);
        return;
      }
      int saveltajanumero=-1;

      if(!((req.getParameter("sukunimi").equals("") && 
          req.getParameter("etunimi").equals("")))){
          hakutulos=stmt.executeQuery(kysely);
          if(hakutulos.next())
            saveltajanumero=hakutulos.getInt("saveltajanumero");        
      }
     
      //jos uusi sveltj, listn tietokantaan
      if(saveltajanumero==-1){
        kysely="INSERT INTO saveltaja VALUES (saveltajatunniste."+
                "NEXTVAL, ";
        kysely+="'"+req.getParameter("etunimi")+"', ";    
        kysely+=" '"+req.getParameter("sukunimi")+"' )";    
        stmt.executeUpdate(kysely);
      }
      //onko teos jo tietokannassa?
      kysely="SELECT tunnistenumero FROM teos WHERE "+
              "saveltaja="+saveltajanumero;
      if(!(req.getParameter("nimi").equals("")))
        kysely+=" AND tNimi='"
                  +req.getParameter("nimi")+"'";
      if(!(req.getParameter("savellysvuosi").equals("")))
        kysely+=" AND savellysvuosi="
                  +req.getParameter("savellysvuosi");
      if(!(req.getParameter("koko").equals("")))
        kysely+=" AND koko="
                  +req.getParameter("koko");
      if(!(req.getParameter("url").equals("")))
        kysely+=" AND URLosoite='"
               +req.getParameter("url")+"'";
      if(!(req.getParameter("lisatiedot").equals("")))
        kysely+=" AND lisatiedot='"
                      +hipsutPois(req.getParameter(
                                    "lisatiedot"))+"'";
      //jos teos jo kannassa, voidaan katsoa se listyksi
      hakutulos=stmt.executeQuery(kysely);
      if(hakutulos.next()){
        if (stmt!=null) stmt.close(); 
        Tietokanta.suljeYhteys(yhteys);
        palaute.println(Nuottilomaketekstit.lisattyKantaan());
        return;
      }
      //muuten listn teos kantaan
      kysely="INSERT INTO teos VALUES (teostunniste.NEXTVAL, '"+
              req.getParameter("nimi")+"', '"+ktunnus+"', ";

      //jos sveltj on juuri listty kantaan, tietokannan 
      //saveltajanumero on sekvenssin tmn hetkinen arvo (ja metodin 
      //saveltajanumero=-1), muuten sveltjnumero on viel 
      //muuttujassa saveltajanumero 

      if(saveltajanumero==-1)
        kysely+="saveltajatunniste.CURRVAL, ";
      else
        kysely+=saveltajanumero+", ";
      
      if(!(req.getParameter("savellysvuosi").equals("")))
        kysely+=req.getParameter("savellysvuosi")+", "; 
      else
        kysely+="null, "; 

      if(!(req.getParameter("koko").equals("")))
        kysely+=req.getParameter("koko")+", ' ";

      else
        kysely+="null, '"; 

      kysely+=req.getParameter("url")+
                "', '"+hipsutPois(req.getParameter("lisatiedot"))+
                "', sysdate)";
      stmt.executeUpdate(kysely);

      int aihenumero=-1;

      //onko listty uusi aihepiiri, jota ei ole tietokannassa?
      if(!(req.getParameter("aihepiiri").equals(""))){
        //onko lisatty aihepiiri jo tietokannassa?

        kysely="SELECT aihenumero FROM aihepiiri "+
               "WHERE nimi='"+req.getParameter("aihepiiri")+"'";
        hakutulos=stmt.executeQuery(kysely);

        if(hakutulos.next()){     //oli jo tietokannassa, ei list
          aihenumero=hakutulos.getInt("aihenumero");
        }        
        else{                     //listn uusi aihepiiri 
          kysely="INSERT INTO aihepiiri VALUES ("+
                 "aihepiiritunniste.NEXTVAL, '"+
                 req.getParameter("aihepiiri")+"')";
          stmt.executeUpdate(kysely);
        }
        //liitetn aihepiiri teokseen yhteystaulun avulla
        kysely="INSERT INTO aiheyhteys VALUES (teostunniste.CURRVAL,";
        if(aihenumero==-1)
          kysely+="aihepiiritunniste.CURRVAL)";
        else
          kysely+=aihenumero+")";
  
        stmt.executeUpdate(kysely); 
      }
      //oliko valittu aihepiirej vaihtoehdoista??
      if(!(req.getParameterValues("vaihepiiri")==null)){
        for(int i=0;i<req.getParameterValues("vaihepiiri").length;i++){
          if(!(req.getParameterValues("vaihepiiri")[i].equals("(ei"+
            "valittu)"))){
              kysely="INSERT INTO aiheyhteys "+
                      "(SELECT teostunniste.CURRVAL, aihenumero FROM "+
                      "aihepiiri WHERE nimi='"+req.getParameterValues(
                      "vaihepiiri")[i]+"')";
              stmt.executeUpdate(kysely);
          }
        }                       
      }
     palaute.println(Nuottilomaketekstit.lisattyKantaan());
    }catch (SQLException e){
      palaute.println(Virheilmoitukset.kielletytMerkit());
    }finally{
      try {
        if (stmt!=null) stmt.close(); 
        Tietokanta.suljeYhteys(yhteys);
      } catch(SQLException e) {}     
    }
  }
  //---------------------------------------------------------------------
  private static String hipsutPois(String muutettava){
    /**poistaa hipsut annetusta merkkijonosta*/
    char[] apu;
		String palautettava="";
		try{
    	if(muutettava==null || muutettava.equals(""))
				return muutettava;
			apu=muutettava.toCharArray();						
			for(int i=0; i<apu.length;i++)
				if(apu[i]=='\'')
           apu[i]=' ';	
			return new String(apu);
		}catch(Exception e){
			return muutettava;		
    }
  }
}
