import java.io.*;
import java.sql.*;
import javax.servlet.*;
import javax.servlet.http.*;
import java.util.*;
/*=======================================================================
Servletti nuottijulkaisun poistamiseen Nuottiarkistosta

kirjoittanut: Ahti Syreeni 
pvm:          23.4.2001
=======================================================================*/

public class Nuotinpoisto extends HttpServlet{
  public void service(HttpServletRequest req, HttpServletResponse res) 
                      throws ServletException, IOException{
    /**metodi poistaa valitun nuottijulkaisun tietokannasta teoksen
       tunnistenumeron perusteella*/

    ServletOutputStream palaute;  
    res.setContentType("text/html");
    palaute= res.getOutputStream();
    String ktunnus=null;
    Cookie[] piparit=req.getCookies();
    String tuhottava;
    String kysely="";
    Statement stmt = null;
    Enumeration poistettavat=req.getParameterNames();

    //Rekisteroitynyt kayttaja?
    for(int i=0;i<piparit.length;i++){
      if(piparit[i].getName().equals("nuottiarkisto")){
         if(!(piparit[i].getValue()==null))
           ktunnus=piparit[i].getValue();
      }
    }

    if(ktunnus==null){
      res.sendRedirect("Etusivu");
      return;
    }
    if(!poistettavat.hasMoreElements()){ //ei ollut valittu poistettavia   
      res.sendRedirect("Nuotinpoistolomake");
      return;
    }

    //listn SQL-kyselyyn valittujen teosten tunnistenumerot
    //poistolomakkeen check-boxit oli nimetty teosten tunnistenumeroilla 

    try{
      kysely="DELETE from teos where tunnistenumero="+    
                        (String)poistettavat.nextElement();
      while(poistettavat.hasMoreElements()){
        kysely+=" OR tunnistenumero="+(String)poistettavat.nextElement();
      }
    }catch(Exception e){
      res.sendRedirect("Nuotinpoistolomake"); 
      return;    //tt ei koskaan pitisi tapahtua
    }
    
    //luodaan yhteys tietokantaan ja suoritetaan poisto
    Connection yhteys=null;
    try{
      yhteys= Tietokanta.luoYhteys();
      if (yhteys==null) {
        palaute.println(Virheilmoitukset.tkYhteysvirhe());
        return;
      }    
      stmt = yhteys.createStatement(); 
      stmt.executeUpdate(kysely);
      res.sendRedirect("Nuotinpoistolomake");
    }catch(SQLException e){
      palaute.println(Virheilmoitukset.SQLVirhe(e.getMessage()));
    }finally{
      try{
       if (stmt!=null) stmt.close(); 
       Tietokanta.suljeYhteys(yhteys);
      } catch(SQLException e) {}     
    }
  }
} 
 
