import java.io.*;
import java.sql.*;
import javax.servlet.*;
import javax.servlet.http.*;

/*=======================================================================
Servletti nuottijulkaisun poistamisen valintalomakkeen generoimiseen

kirjoittanut: Ahti Syreeni 
pvm:          23.4.2001
=======================================================================*/

public class Nuotinpoistolomake extends HttpServlet{
  public void service(HttpServletRequest req, HttpServletResponse res) 
                      throws ServletException, IOException{
    ServletOutputStream palaute;  
    res.setContentType("text/html");
    palaute= res.getOutputStream();        
    String ktunnus=null;
    Cookie[] piparit=req.getCookies();

    //Rekisteroitynyt kayttaja?
    for(int i=0;i<piparit.length;i++){
      if(piparit[i].getName().equals("nuottiarkisto")){
         if(!(piparit[i].getValue()==null))
           ktunnus=piparit[i].getValue();
      }
    }

    if(ktunnus==null){
      res.sendRedirect("Etusivu");
    }
    else{
      palaute.println(Nuotinpoistotekstit.aluste());
      //luodaan yhteys tietokantaan
      Connection yhteys=null;
      yhteys= Tietokanta.luoYhteys();
      if (yhteys==null) {
        palaute.println(Virheilmoitukset.tkYhteysvirhe());
        return;
      }

      //katsotaan tietokannassa, onko kyttj arkistonhoitaja
      Statement stmt = null;
      ResultSet hakutulos = null; 
      String kysely="";
      boolean arkistonhoitaja=false;

      try { 
        stmt = yhteys.createStatement(); 
        kysely="SELECT DISTINCT oikeudet FROM kayttajatiedot"+
               "  WHERE kayttajatunnus='"+ktunnus+"'"; 
        hakutulos = stmt.executeQuery(kysely);  
        if(!hakutulos.next()){
          if (hakutulos!=null) hakutulos.close(); 
          if (stmt!=null) stmt.close(); 
          Tietokanta.suljeYhteys(yhteys);
          return;
        }
        if(!(hakutulos.getString("oikeudet")==null))
          arkistonhoitaja=true;

        if(!arkistonhoitaja)
          kysely="SELECT distinct tunnistenumero, tNimi, lisaaja, sSukunimi, "+
               "  sEtunimi, URlosoite, lisayspaiva FROM teos, saveltaja "+
               "  WHERE lisaaja='"+ktunnus+"' AND saveltaja=saveltajanumero "+
               "  ORDER BY sSukunimi, sEtunimi,tNimi"; 
      
        else
          kysely="SELECT distinct kayttajatunnus,  tunnistenumero, tNimi, "+ 
                 "  lisaaja, sSukunimi,"+
                 "  sEtunimi, URlosoite, lisayspaiva FROM teos, saveltaja, "+
                 "  kayttajatiedot WHERE lisaaja=kayttajatunnus AND "+
                 "  saveltaja=saveltajanumero GROUP BY kayttajatunnus,"+
                 "  tunnistenumero, tNimi, lisaaja, sSukunimi,"+
                 "  sEtunimi, URlosoite, lisayspaiva"+
                 "  ORDER BY kayttajatunnus, sSukunimi, sEtunimi, tNimi"; 

        hakutulos = stmt.executeQuery(kysely);  
        palaute.println(Nuotinpoistotekstit.lomake());           
        palaute.println(Nuotinpoistotekstit.napit());           
        
        if(!arkistonhoitaja)
          palaute.println(Nuotinpoistotekstit.lomakeotsikko(false));           
        else
          palaute.println(Nuotinpoistotekstit.lomakeotsikko(true));           
        
        String lisaaja=null;

        while(hakutulos.next()){          
            if(arkistonhoitaja)
              lisaaja=hakutulos.getString("lisaaja");              
            palaute.println(Nuotinpoistotekstit.teosrivi(
                                      hakutulos.getString("sSukunimi"),
                                      hakutulos.getString("sEtunimi"),
                                      hakutulos.getString("tNimi"),
                                      hakutulos.getString("lisayspaiva"),
                                      lisaaja,
                                      hakutulos.getInt("tunnistenumero"),
                                      hakutulos.getString("URLosoite")
                                      ));                       

        }
        
        palaute.println(Nuotinpoistotekstit.napit());           
        palaute.println(Nuotinpoistotekstit.lomakelopuke());           
        palaute.println(Nuotinpoistotekstit.linkit());           
        
        if(arkistonhoitaja){
          kysely="SELECT distinct kayttajatunnus, kEtunimi, kSukunimi,"+
                 "sahkopostiosoite FROM kayttajatiedot ORDER BY "+
                 "kSukunimi, kEtunimi";
          hakutulos = stmt.executeQuery(kysely);  

          palaute.println(Nuotinpoistotekstit.kayttajatietotaulukko());
          while(hakutulos.next())          
            palaute.println(Nuotinpoistotekstit.kayttajatietorivi(
                                hakutulos.getString("kayttajatunnus"),
                                hakutulos.getString("kSukunimi"),
                                hakutulos.getString("kEtunimi"),
                                hakutulos.getString("sahkopostiosoite")
                                ));           
          palaute.println(Html.taulukkolopetus());  
          palaute.println(Nuotinpoistotekstit.linkit());
        }

        palaute.println(Html.lopetus());
      }catch (SQLException e){
       palaute.println(Virheilmoitukset.SQLVirhe(e.getMessage())); 
      }finally{
       try {
         if (hakutulos!=null) hakutulos.close(); 
         if (stmt!=null) stmt.close(); 
         Tietokanta.suljeYhteys(yhteys);
       } catch(SQLException e) {}
      }     
    }
  }
} 
 
