import java.io.*;
import java.sql.*;
import javax.servlet.*;
import javax.servlet.http.*; 

/*=======================================================================
Servletti Nuottiarkiston nuotinlisyslomakkeen generoimiseen.

kirjoittanut: Ahti Syreeni 
pvm:          23.4.2001
=======================================================================*/
public class Nuottilomake extends HttpServlet{
  public void service(HttpServletRequest req, HttpServletResponse res) 
                      throws ServletException, IOException{
    /**generoi nuotinlisyslomakkeen*/

    ServletOutputStream palaute;  
    res.setContentType("text/html");
    palaute= res.getOutputStream();        
    boolean rekisteroitunut=false;
    Cookie[] piparit=req.getCookies();

    //Rekisteroitynyt kyttaj?
    for(int i=0;i<piparit.length;i++){
      if(piparit[i].getName().equals("nuottiarkisto")){
         if(!(piparit[i].getValue()==null))
           rekisteroitunut=true;
      }
    }

    if(!rekisteroitunut){  //toiminto vaatii rekisteritymisen
      res.sendRedirect("Etusivu");
    }
    else{
      palaute.println(Nuottilomaketekstit.aluste());
      palaute.println(Nuottilomaketekstit.linkit());

      //luodaan yhteys tietokantaan
      Connection yhteys=null;
      yhteys= Tietokanta.luoYhteys();
      if (yhteys==null) {
        palaute.println(Virheilmoitukset.tkYhteysvirhe());
        return;
      }

      //haetaan aihepiirien nimet tietokannasta
      Statement stmt = null;
      ResultSet hakutulos = null; 
      String[] tulostaulukko; 

      try { 
        stmt = yhteys.createStatement(); 
        hakutulos = stmt.executeQuery("SELECT DISTINCT nimi FROM "+
                                        " aihepiiri ORDER BY nimi");  
 
        tulostaulukko=new String[hakutulos.getFetchSize()];
      
        for(int i=0; i<hakutulos.getFetchSize();i++)
          if(hakutulos.next())
            tulostaulukko[i]=hakutulos.getString(1);   

        palaute.println(Nuottilomaketekstit.lomake(tulostaulukko));
        palaute.println(Html.lopetus());
      }catch (SQLException e){
        palaute.println(Virheilmoitukset.SQLVirhe(e.getMessage())); 
        //ei pitisi koskaan tapahtua... 
      }finally{
       try {
         if (hakutulos!=null) hakutulos.close(); 
         if (stmt!=null) stmt.close(); 
         Tietokanta.suljeYhteys(yhteys);
       } catch(SQLException e) {}
      }     
    }
  }
} 
