/**=======================================================================
Kirjastoluokka Nuottiarkiston nuotilisyslomakkeen tekstien tallentamiseen
Kaikki tekstit ovat html-muodossa ja luokan metodit palauttavat 
tekstit html-muodossa.

kirjoittanut: Ahti Syreeni 
pvm:          26.4.2001
=======================================================================*/

public class Nuottilomaketekstit{
  //*********************************************************************
  private static final String tausta=
                        "http://db.cs.helsinki.fi/u/asyreeni/tausta.jpg";
  //*********************************************************************
  public static String aluste(){
    /**palauttaa nuotinlisyslomakesivun alusteen. Aluste sislt mys
       lyhyet ohjeet*/

    return Html.aluste("Nuottiarkisto -nuottijulkaisun lis&auml;ys",tausta)+
           Html.otsikko("Nuottijulkaisun lis&auml;ys arkistoon",1)+"\n"+
      "<p>Voit lis&auml;t&auml; l&ouml;yt&auml;mi&auml;si"+
      "   nuottijulkaisuja nuottiarkistoon muiden\n iloksi. Muista"+
      "   kuitenkin olevasi vastuussa siit&auml;, ett&auml; teos on"+
      "   luvallisesti esill&auml;. Nuottiarkistoon ei saa lis&auml;"+
      "   t&auml; linkkej&auml; tekij&auml;noikeuksia rikkoviin"+
      "   sivustoihin.<strong>Sytteiss ei saa olla hipsuja."+ 
      "    </strong>Ylempi s&auml;velt&auml;j&auml;kentt&auml; on"+ 
      "   s&auml;velt&auml;j&auml;n etunimelle,"+
      "   alempi sukunimelle. Aihepiirilista on monivalittava ja voit\n"+
      "   my&ouml;s lis&auml;t&auml; oman aihepiirin. \n"+ 
      "</p>";
  }
  //---------------------------------------------------------------------
  public static String lomake(String[] aihepiirit){
    /**palauttaa koko lomakkeen annetuilla aihepiireill*/
    String palaute=lomakeA();

    if(aihepiirit==null)
      return "";    

    palaute+=    
      "    <tr>\n"+
   	  "      <td rowspan=\"2\"><label for=\"vaihepiiri\">Aihepiiri:"+
                              "</label></td>\n"+
      "      <td><select multiple=\"multiple\" name=\"vaihepiiri\" "+ 
                 "size=\"4\" style=\"width:100%;\">"+
      "            <option selected>(ei valittu)\n";

    if(aihepiirit.length>0){       //sitten annetut aihepiirit valikkoon
      for(int i=0;i<aihepiirit.length;i++)
	      if(!(aihepiirit[i]==null))
         palaute+="            <option>"+aihepiirit[i]+"\n";   
    }
    palaute+="          </select>\n";    
    palaute+=lomakeB();
    return palaute;      
  }
  //---------------------------------------------------------------------
  public static String linkit(){
    /**palauttaa sivun linkit*/
    String palaute=
      "<p>"+Html.linkki("Etusivu ","Etusivu")+"--"+
      Html.linkki("Nuotinpoisto","Nuotinpoistolomake")+"--\n  "+     
      Html.linkki("Henkil&ouml;tietojen muuttaminen",
                  "Rekisterointilomake")+"--"+     
      Html.linkki("Nuotinlis&auml;ys","Nuottilomake")+"--"+     
      Html.linkki("Lopetus",
                  "Logout")+"\n"+     

      "</p>";
    return palaute;
  }    
  //---------------------------------------------------------------------
  private static String lomakeA(){
    /**palauttaa lomakkeen ennen vaihtuvia aihepiirej olevat osat*/
    return
      "<form method=\"post\" action=\"Nuotinlisays\">\n"+
      "  <table border=1 style=\"width:100%;\">\n"+
      "    <col style=\"width:30%;\"><col style=\"width:70%;\">\n"+
      "    <tr>\n"+
      "   	 <td><label for=\"nimi\"><em>Teoksen nimi:</em></label>"+
                  "</td>\n"+
      "      <td><input type=\"text\"name=\"nimi\""+
                  "style=\"width:100%;\"></td>\n"+
      "    </tr>\n"+
      "    <tr>\n"+
      "      <td><label for=\"saveltaja\">S&auml;velt&auml;j&auml;:"+
                  "</label></td>\n"+
      "      <td><label for=\"etunimi\">Etunimi:</label>\n"+
      "          <input type=\"text\" name=\"etunimi\" "+
                  "style=\"width:100%;\">\n"+
      "          <label for=\"sukunimi\">Sukunimi:</label>\n"+
      "          <input type=\"text\" name=\"sukunimi\" "+
                  "style=\"width:100%;\"></td>\n"+
      "    </tr>\n"+
      "    <tr>\n"+
   	  "      <td><label for=\"savellysvuosi\">S&auml;vellysvuosi:"+
                 "</label></td>\n"+
      "      <td><input type=\"text\" name=\"savellysvuosi\""+
                  "style=\"width:100%;\" maxlength=\"4\"></td>\n"+
      "    </tr>\n";
  } 
  //---------------------------------------------------------------------
  private static String lomakeB(){
    /**palauttaa lomakkeen aihepiirin jlkeiset osat*/
    return
      "  <tr>\n"+
    	"    <td><label for=\"aihepiiri\">Uusi aihepiiri:</label>\n"+
      "   		  <input type=\"text\" name=\"aihepiiri\" "+ 
                "style=\"width:100%;\"></td>\n"+
      "  </tr>\n"+
      "  <tr>\n"+
     	"    <td><label for=\"koko\">Koko:</label></td>\n"+
      "    <td><input type=\"text\" name=\"koko\" "+ 
               "style=\"width:100%;\"></td>\n"+
      "  </tr>\n"+
      "  <tr>\n"+
   	  "    <td><em><label for=\"url\">URL-osoite:</label></em></td>\n"+
      "    <td><input type=\"text\" name=\"url\" "+ 
               "style=\"width:100%;\"></td>\n"+
      "  </tr>\n"+
      "  <tr>\n"+
   	  "    <td><label for=\"lisatiedot\">Lis&auml;tiedot:</label>"+
               "</td>\n"+
      "    <td><textarea name=\"lisatiedot\" style=\"width:100%;\">"+
              "</textarea></td>\n"+
      "  </tr>\n"+
      "  <tr>\n"+
      "    <td><input type=\"submit\" value=\"L&auml;het&auml;\">\n"+
    	"        <input type=\"reset\" value=\"Tyhjenn&auml;\"></td>\n"+
      "  </tr>\n"+
      "</table>";
  }
  //---------------------------------------------------------------------
  public static String lisattyKantaan(){
    /**palauttaa ilmoituksen siit, ett teos on onnistuneesti listty
       tietokantaan*/

    return Html.aluste("Nuottiarkisto -Nuottijulkaisu lis&auml;tty",
                       tausta)+
           Html.otsikko("Nuottijulkaisu lis&auml;tty kantaan",1)+
           "\n"+linkit();
  }
  

}
