import java.io.*;
import java.sql.*;
import javax.servlet.*;
import javax.servlet.http.*;

/*=======================================================================
Servletti Nuottiarkiston rekisterintilomakkeen ksittelemiseen.

kirjoittanut: Ahti Syreeni 
pvm:          23.4.2001
=======================================================================*/
public class Rekisterointi extends HttpServlet{
  //*********************************************************************
  //nimi, josta tunnistetaan nuottiarkiston tekem tunnistepipari
  private static final String piparinimi="nuottiarkisto"; 
  //*********************************************************************
  public void service(HttpServletRequest req, HttpServletResponse res) 
                      throws ServletException, IOException {
    /**lis rekisterityneen kyttjn tiedot tietokantaan*/
    
    ServletOutputStream palaute;  
    res.setContentType("text/html");
    palaute= res.getOutputStream();        
    String ktunnus=null;
    Cookie[] piparit=req.getCookies();

    //onko salasanan varmistus oikein...
    if(!(req.getParameter("salasana1").equals(req.getParameter(
                                              "salasana2")))){
      palaute.println(Virheilmoitukset.salasanavirhe());
      return;
    }

    //onko sukunimi varmasti annettu?
    if(req.getParameter("sukunimi").equals("")){
      palaute.println(Virheilmoitukset.sukunimi());
      return;
    }

    //onko kysymyksess uusi kyttj?
    for(int i=0;i<piparit.length;i++){
      if(piparit[i].getName().equals("nuottiarkisto")){
         if(!(piparit[i].getValue()==null))
            ktunnus=piparit[i].getValue();
      }
    }
    
    String kysely=null;
    if(ktunnus==null){ //tehdn uusi rekisterinti
      if(req.getParameter("ktunnus").equals("")){
        //kyttjtunnusta ei annettu
        palaute.println(Virheilmoitukset.ktunnus());
        return;
      }
      //leivotaan pipari ja katsotaan onnistuuko
      try{
        Cookie tunnistepipari=new Cookie(piparinimi,
                                        req.getParameter("ktunnus"));
        tunnistepipari.setMaxAge(-1); //pipari hvi suljettaessa
                                      //selain
        res.addCookie(tunnistepipari);
      }catch(Exception e){
        //kyttjtunnus sislt kiellettyj merkkej
        palaute.println(Virheilmoitukset.ktunnusLaiton());
        return;
      }
      kysely="INSERT INTO kayttajatiedot VALUES("+
                    "'"+req.getParameter("ktunnus")+"'"+
                    ", '"+req.getParameter("etunimi")+"'"+
                    ", '"+req.getParameter("sukunimi")+"'"+
                    ", '"+req.getParameter("sposti")+"'"+
                    ", '"+req.getParameter("salasana1")+"'"+
                    ", '')";
    }
    else{   //muutetaan jo tietokannassa olevia tietoja
      if(req.getParameter("poisto")==null)
        kysely="UPDATE kayttajatiedot SET "+
                   "kEtunimi='"+req.getParameter("etunimi")+"', "+
                   "kSukunimi='"+req.getParameter("sukunimi")+"', "+
                   "sahkopostiosoite='"+req.getParameter("sposti")+"', "+
                   "salasana='"+req.getParameter("salasana1")+"' "+
                   "WHERE kayttajatunnus='"+ktunnus+"'";
      else
        kysely="DELETE from kayttajatiedot WHERE kayttajatunnus='"+
                ktunnus+"'";
    }   
    Connection yhteys=null;
    yhteys= Tietokanta.luoYhteys();

    if (yhteys==null) {
      res.sendRedirect("Logout");
      palaute.println(Virheilmoitukset.tkYhteysvirhe());
      return;
    }

    Statement stmt = null;
    int onnistuminen=0;  
    try { 
      stmt = yhteys.createStatement(); 
      onnistuminen= stmt.executeUpdate(kysely);        
      if(onnistuminen==0)
          palaute.println(Virheilmoitukset.SQLVirhe("Lisays ei onnistunut")); 
      else{
        if(req.getParameter("poisto")==null)
          res.sendRedirect("Etusivu");
        else
          res.sendRedirect("Logout");
      }
    }catch (SQLException e){
      try{
        //jo annettu tunnistepipari on tuhottava
        Cookie tunnistepipari2=new Cookie(piparinimi,null);
        tunnistepipari2.setMaxAge(0); 
        res.addCookie(tunnistepipari2);
      }catch(Exception a){} 
      palaute.println(Virheilmoitukset.kielletytMerkit()); 
    }finally{
      try {
        if (stmt!=null) stmt.close(); 
        Tietokanta.suljeYhteys(yhteys);
      } catch(SQLException e) {}     
    }
  }
}
