import java.io.*;
import java.sql.*;
import javax.servlet.*;
import javax.servlet.http.*;

/**======================================================================
Servletti Nuottiarkiston rekisteritymislomakkeen generoimiseen. 

kirjoittanut: Ahti Syreeni 
pvm:          26.4.2001
=======================================================================*/
public class Rekisterointilomake extends HttpServlet{
  public void service(HttpServletRequest req, HttpServletResponse res) 
                      throws ServletException, IOException {
    /**generoi rekisteritymislomakkeen*/

    ServletOutputStream palaute;  
    res.setContentType("text/html");
    palaute= res.getOutputStream();        
    String ktunnus=null;
    Cookie[] piparit=req.getCookies();

    for(int i=0;i<piparit.length;i++){
      if(piparit[i].getName().equals("nuottiarkisto")){
         if(!(piparit[i].getValue()==null))
            ktunnus=piparit[i].getValue();
      }
    }

    if(ktunnus==null){ //uusi kyttj, generoidaan uusi lomake
      palaute.println(Rekisterointitekstit.aluste(false));
      palaute.println(Rekisterointitekstit.ohjeet(false));
      palaute.println(Rekisterointitekstit.reklomake());
      palaute.println(Rekisterointitekstit.linkit(false));
      palaute.println(Html.lopetus());
      return;
    }
    //kysymyksess tietojen muuttaminen ja haetaan tmnhetkiset
    //tiedot tietokannasta

    Connection yhteys=null;
    yhteys= Tietokanta.luoYhteys();

    if (yhteys==null) {
      palaute.println(Virheilmoitukset.tkYhteysvirhe());
      return;
    }

    String kysely="SELECT kEtunimi, kSukunimi, sahkopostiosoite, "+
                  "salasana FROM kayttajatiedot WHERE kayttajatunnus="+
                  "'"+ktunnus+"'";

    Statement stmt = null;
    ResultSet hakutulos = null;  
    try { 
      stmt = yhteys.createStatement(); 
      hakutulos = stmt.executeQuery(kysely);  
      if(hakutulos.next()){
        palaute.println(Rekisterointitekstit.aluste(true));
        palaute.println(Rekisterointitekstit.ohjeet(true));
        palaute.println(Rekisterointitekstit.muutoslomake(
                                                hakutulos.getString(1),
                                                hakutulos.getString(2),
                                                hakutulos.getString(3),
                                                ktunnus,
                                                hakutulos.getString(4)));
        palaute.println(Rekisterointitekstit.linkit(true));
        palaute.println(Html.lopetus());  
      }
      else
        res.sendRedirect("Etusivu");
      
    }catch (SQLException e){
      palaute.println(Virheilmoitukset.SQLVirhe(e.getMessage())); 
    }finally{
      try {
        if (hakutulos!=null) hakutulos.close(); 
        if (stmt!=null) stmt.close(); 
        Tietokanta.suljeYhteys(yhteys);
      } catch(SQLException e) {}     
    }
  }
}
