/**======================================================================
Kirjastoluokka Nuottiarkiston rekisterintilomakkeen tekstien 
tallentamiseen. Kaikki tekstit ovat html-muodossa ja luokan metodit 
palauttavat tekstit html-muodossa.

kirjoittanut: Ahti Syreeni 
pvm:          26.4.2001
=======================================================================*/
public class Rekisterointitekstit{
  //*********************************************************************
  private static final String tausta=
                        "http://db.cs.helsinki.fi/u/asyreeni/tausta.jpg";
  //*********************************************************************
  public static String aluste(boolean muutoslomake){
    /**palauttaa sivun html-alusteen*/
    if(!muutoslomake){
      return Html.aluste("Nuottiarkisto -Rekister&ouml;tyminen",tausta)+     
             Html.otsikko("Rekister&ouml;itymislomake",1);
    }
    else{   
      return Html.aluste("Nuottiarkisto -Henkil&ouml;tietojen "+
                         "muuttaminen",tausta)+     
             Html.otsikko("Henkil&ouml;tietojen muuttaminen",
             1);
    }
  }
  //---------------------------------------------------------------------
  public static String ohjeet(boolean muutoslomake){
    /**palauttaa ohjeet lomakkeen tyttmiseen*/
    if(muutoslomake)
      return  "  <p>\n"+
              "    Voit muuttaa kaikkia muita tietojasi, paitsi\n "+
              "    k&auml;ytt&auml;j&auml;tunnustasi\n.Voit my&ouml;s\n"+
              "    poistaa henkil&ouml;tietosi"+ 
              "    valitsemalla henkil&ouml;tietojen poiston\n. Samalla\n"+
              "    kuitenkin poistuvat my&ouml;s lis&auml;&auml;m&auml;si"+
              "    teokset Nuottiarkistosta.\n"+
              "  </p>\n";
    if(!muutoslomake)
      return  "  <p>\n"+
              "    Ole hyv&auml; ja anna henkil&ouml;tietosi alla\n"+ 
              "    oleviin kenttiin. K&auml;ytt&auml;j&auml;tunnus ja\n"+ 
              "    sukunimi ovat pakollisia.\n"+
              "  </p>\n"+
              "  <p>\n"+
              "    <strong>K&auml;ytt&auml;j&auml;tunnus on\n"+ 
              "    enimmill&auml;&auml;n kymmenen kirjaimen mittainen.\n"+ 
              "    Salasana annetaan molempiin\n"+ 
              "    salasanakenttiin ja niiden on oltava\n"+ 
              "    t&auml;sm&auml;lleen samat. \n Ota huomioon,\n"+ 
              "    ett&auml; arkistonhoitaja n&auml;kee salasanasi.\n"+
              "    Mitk&auml;&auml;n sivun kent&auml;t eiv&auml;t saa \n"+
              "    sis&auml;lt&auml;&auml; hipsuja. "+
              "    </strong> L&auml;hetetty&auml;si lomakkeen, p&auml;"+
                   "&auml;set rekister&ouml;ityneiden etusivulle."+    
              "  </p>\n";
   return null;
  }
  //---------------------------------------------------------------------
  public static String reklomake(){
    /**palauttaa rekisteritymislomakkeen*/
    return 
       "<form method=\"post\" action=Rekisterointi>\n"+
       "<table style=\"width:100%;\">"+
       "  <col style=\"width:30%;\"><col style=\"width:70%;\">\n"+
       "  <tr>\n"+
       "    <td><label for=\"etunimi\">Etunimi:</label></td>\n"+
       "    <td><input type=\"text\" name=etunimi maxlength=20 style=\n"+
       "         \"width:100%;\"></td>\n"+
       "  </tr>\n"+
       "  <tr>\n"+
       "  <td><em><label for=\"sukunimi\">Sukunimi:</label></em></td>\n"+
       "    <td><input type=\"text\" name=sukunimi maxlength=20\n"+
       "        style=\"width:100%;\"></td>\n"+
       "  </tr>\n"+
       "  <tr>\n"+
 	     "    <td><label for=\"sposti\">S&auml;hk&ouml;posti:</label></td>\n"+
       "    <td><input type=\"text\" name=sposti maxlength=50\n"+
       "        style=\"width:100%;\"></td>\n"+
       "  </tr>\n"+
       "  <tr>\n"+
       "    <td><em><label for=\"ktunnus\">K&auml;ytt&auml;j&auml;tunnus:\n"+
       "        </label></em></td>\n"+
       "    <td><input type=\"text\" name=ktunnus maxlength=10\n"+
       "        style=\"width:100%;\"></td>\n"+
       "  </tr>\n"+
       "  <tr>\n"+
     	 "    <td><label for=\"salasana1\">Salasana:</label></td>\n"+
       "    <td><input type=\"password\" name=salasana1 maxlength=10\n"+
       "        style=\"width:100%;\"></td>\n"+
       "  </tr>\n"+
       "  <tr>\n"+
 	     "    <td><label for=\"salasana2\">Salasana:</label></td>\n"+
       "    <td><input type=\"password\" name=salasana2 maxlength=10\n"+
       "        style=\"width:100%;\"></td>\n"+
       "  </tr>\n"+
       "  <tr>\n"+
       "    <td><input type=\"submit\" value=\"L&auml;het&auml;\">\n"+
  	   "        <input type=\"reset\" value=\"Tyhjenn&auml;\"></td> \n"+
       "  </tr> \n "+
       "</table>\n";
  }
  //---------------------------------------------------------------------
  public static String muutoslomake(String eNimi, String sNimi, 
                                    String email, String kTunnus,
                                    String sSana){
    /**palauttaa henkiltietojen muutoslomakkeen esitytettyn
       annetuilla parametereilla*/

    //poistetaan null-arvot (ja vltetn null-poikkeus...)
    if(eNimi==null)
      eNimi="";
    else
      if(eNimi.equals("null"))
        eNimi="";
    if(email==null)
      email="";
    else
      if(email.equals("null"))
        email="";
    if(sSana==null)
      sSana="";
    else
      if(sSana.equals("null"))
        sSana="";
    return 
      ("<form method=\"post\" action=Rekisterointi>\n"+
       "<table style=\"width:100%;\">"+
       "  <col style=\"width:30%;\"><col style=\"width:70%;\">\n"+
       "  <tr>\n"+
       "    <td><label for=\"etunimi\">Etunimi:</label></td>\n"+
       "    <td><input type=\"text\" name=etunimi maxlength=20"+
       "         value=\""+eNimi+"\" style=\"width:100%;\"></td>\n"+
       "  </tr>\n"+
       "  <tr>\n"+
       "  <td><em><label for=\"sukunimi\">Sukunimi:</label></em></td>\n"+
       "    <td><input type=\"text\" name=sukunimi maxlength=20\n"+
       "        value=\""+sNimi+"\" style=\"width:100%;\"></td>\n"+
       "  </tr>\n"+
       "  <tr>\n"+
 	     "    <td><label for=\"sposti\">S&auml;hk&ouml;posti:</label>"+
                "</td>\n"+
       "    <td><input type=\"text\" name=sposti maxlength=50\n"+
       "        value=\""+email+"\"style=\"width:100%;\"></td>\n"+
       "  </tr>\n"+
       "  <tr>\n"+
       "    <td><em><label for=\"ktunnus\">K&auml;ytt&auml;j&auml;"+
                    "tunnus:\n"+
       "        </label></em></td>\n"+
       "    <td>"+kTunnus+"</td>\n"+
       "  </tr>\n"+
       "  <tr>\n"+
     	 "    <td><label for=\"salasana1\">Salasana:</label></td>\n"+
       "    <td><input type=\"password\" name=salasana1 maxlength=10\n"+
       "        value=\""+sSana+"\" style=\"width:100%;\"></td>\n"+
       "  </tr>\n"+
       "  <tr>\n"+
 	     "    <td><label for=\"salasana2\">Salasana:</label></td>\n"+
       "    <td><input type=\"password\" name=salasana2 maxlength=10\n"+
       "        value=\""+sSana+"\"style=\"width:100%;\"></td>\n"+
       "  </tr>\n"+
       "  <tr>\n"+
       "    <td><input type=\"checkbox\" name=poisto>Henkil&ouml;tietojen"+ 
                " poisto\n"+
       "    <td><input type=\"submit\" value=\"L&auml;het&auml;\">\n"+
  	   "        <input type=\"reset\" value=\"Tyhjenn&auml;\"></td>\n "+
       "  </tr> \n "+ 
       "</table>\n");
  }
  //---------------------------------------------------------------------
  public static String linkit(boolean muutoslomake){
    /**palauttaa sivun linkit*/
    String palaute="  <p>\n"+"    "+Html.linkki("Etusivu ","Etusivu");
    if(muutoslomake)
      palaute+="\n--"+Html.linkki("Nuotinlisays",
                                    "Nuottilomake")+"\n"+
               "--"+Html.linkki("Nuotinpoistolomake",
                                  "Nuotinpoistolomake")+"\n"+     
               "--"+Html.linkki("Lopetus","Logout")+"\n";
    palaute+="  </p>\n";
    return palaute;
  }
} 
