import Html;
/*=======================================================================
Kirjastoluokka Nuottiarkiston virheilmoitusten tallentamiseen
Kaikki tekstit ovat html-muodossa ja luokan metodit palauttavat 
tekstit html-muodossa.

kirjoittanut: Ahti Syreeni 
pvm:          30.4.2001
=======================================================================*/
public class Virheilmoitukset{
  //********************************************************************* 
  //osoite, johon lhetetn odottamattomat virheilmoitukset
  private static final String toimittaja=
    "  <p>\n"+
    "    Ahti Syreeni <br>\n"+
    "    050-3673368  <br>\n"+
    "    "+Html.email("ahti.syreeni@helsinki.fi",
                    "ahti.syreeni@helsinki.fi")+"\n"+
    "  </p>\n";
  //********************************************************************* 
  //kytettv taustakuva  
  private static final String tausta=
                        "http://db.cs.helsinki.fi/u/asyreeni/tausta.jpg";
  //********************************************************************* 
  public static String tkYhteysvirhe(){
    /**palauttaa tietokantayhteysvirheilmoituksen*/
    String virheselite=
      "Tietokanta yhteys on t&auml;ll&auml; hetkell&auml; poikki, joten"+
      "\n    t&auml;m&auml;n ohjelman k&auml;tt&oauml; ei ole \n"+
      "    mahdollista. Ole hyv&auml; ja yrit&auml; my&oauml;hemmin\n"+
      "    uudelleen.";

    return virheilmoitus("Tietokanta yhteys poikki",virheselite,null);
  }
  //---------------------------------------------------------------------
  public static String SQLVirhe(String virhe){
    /**palauttaa SQL-virheilmoituksen*/
    String virheselite=
      "Tapahtui odottamaton ohjelmoinnista johtuva virhe";

    return virheilmoitus("Virhe",virheselite,virhe);
  }
  //---------------------------------------------------------------------
  public static String eiNumero(){
    /**palauttaa ilmoituksen virheellisest numeroarvosta*/
    String virheselite=
      "Antamasi lomakkeen jossakin kent&auml;ss&auml; on "+
      "virhe. Ole hyv&auml; ja tarkista antamasi "+
      "arvot: numerokent&auml;ss&auml; saa olla vain numeroita ja "+
      "hipsuja ei saa olla miss&auml;&auml;n kent&auml;ss&auml. "+
      "<em>Jos olit rekister&ouml;itym&auml;ss&auml;, saattaa antamasi "+
      "k&auml;ytt&auml;j&auml;tunnus "+
      "olla jo k&auml;yt&ouml;ss&auml;, kokeile toista. </em>";
    return virheilmoitus("Virheellinen arvo",virheselite,null);
  }
  //---------------------------------------------------------------------
  public static String salasanavirhe(){
    /**palauttaa virheilmoituksen vrst salasanasta*/
    String virheselite=
      "Antamassasi salasanassa on virhe. Molempien antamiesi salasanojen "+
      "on oltava t&auml;sm&auml;lleen samat. Ole hyv&auml; ja tarkista "+
      "antamasi salasanat."; 
    return virheilmoitus("Virheellinen salasana",virheselite,null);
  }
  //---------------------------------------------------------------------
  public static String ktunnus(){
    /**palauttaa virheilmoituksen kyttjtunnuksen puuttumisesta*/
    String virheselite=
      "Et antanut k&auml;ytt&auml;j&auml;tunnusta. Se on annettava "+
      "Palaa takaisin ja anna kunnollinen k&auml;ytt&auml;j&auml;tunnus."; 
    return virheilmoitus("K&auml;ytt&auml;j&auml;tunnus puuttuu",
                          virheselite,null);
  }
  //---------------------------------------------------------------------
  public static String ktunnusLaiton(){
    /**palauttaa virheilmoituksen kyttjtunuksesta, jossa kiellettyj
       merkkej*/
    String virheselite=
      "Antamasi k&auml;ytt&auml;j&auml;tunnus sis&auml;lt&auml;&auml;"+
      "kiellettyj&auml; merkkej&auml;."+
      "K&auml;ytt&auml;j&auml;tunnus ei saa sis&auml;lt&auml;&auml; "+
      "erikoismerkkej&auml;, "+
      "kuten \"*!#%&\'. Ole hyv&auml; ja anna uusi "+
      "k&auml;ytt&auml;j&auml;tunnus"; 
    return virheilmoitus("Virheellinen k&auml;ytt&auml;j&auml;tunnus",
                          virheselite,null);

  }
  //---------------------------------------------------------------------
  public static String sukunimi(){
    /**palauttaa virheilmoituksen sukunimen puuttumisesta*/
    String virheselite=
      "Et antanut sukunime&auml;si. Se on annettava "+
      "Palaa takaisin ja anna sukunimesi."; 
    return virheilmoitus("Sukunimi puuttuu",
                          virheselite,null);
  }
  //---------------------------------------------------------------------
  public static String eiPipareita(){
    /**palauttaa virheilmoituksen siit&auml;, ettei tunniste piparia voi 
       asettaa*/
    String virheselite=
      "Selaimesi ei tue ev&auml;steit&auml; (Cookies) tai olet kytkenyt ne "+
      "pois p&auml;&auml;lt&auml;. Kytke ev&auml;steet p&auml;&auml;lle "+
      "ja yrit&auml; uudelleen"; 
    return virheilmoitus("Ev&auml;steet eiv&auml;t toimi",
                          virheselite,null);
  }
  //---------------------------------------------------------------------
  public static String login(){
    /**palauttaa virheilmoituksen vrst kyttjtunnuksesta tai 
       salasanasta*/
    String virheselite=
      "Antamasi salasana tai k&auml;ytt&auml;j&auml;tunnus on "+
      "v&auml;&auml;rin tai et ole "+
       Html.linkki("rekister&ouml;itynyt.","Rekisterointilomake")+
      "Yrit&auml; uudestaan.";
    return virheilmoitus("Sis&auml;&auml;nkirjoittautuminen ep&auml;onnistui",
                          virheselite,null);
  }
  //---------------------------------------------------------------------
  public static String eiNuottitietoja(){
    /**palauttaa virheilmoituksen puuttuvasta tiedosta*/
    String virheselite=
      "Tarkista antaneesi teokselle nimen ja URL-osoitteen"+    
      "palaa takaisin ja lis&auml;&auml; puuttuvat tiedot"+
      "\n";
    return virheilmoitus("Lomakkeessa puuttuvia pakollisia tietoja",
                          virheselite,null);
  }
  //---------------------------------------------------------------------
  public static String kielletytMerkit(){
    /**palauttaa virheilmoituksen vrist arvoista*/
    return eiNumero();
  }
  //---------------------------------------------------------------------
  private static String virheilmoitus(String virheotsikko, String
                                     virheselitys, String SQLvirhe){
    /**generoi virheilmoituksen*/

    String palaute;
    palaute=Html.aluste("Virheilmoitus",tausta)+
            Html.otsikko(virheotsikko,1)+
            "  <p>\n    "+virheselitys+"\n  </p>\n";
    if(SQLvirhe!=null)
      palaute+="  <p>\n"+
               "    Tietokanta antoi seuraavanlaisen virheilmoituksen:\n"+
               "    <br>"+SQLvirhe+"<br>\n"+"T&auml;llaista ei pit&auml;isi"+
               "    tapahtua, joten ota yhteys ohjelman toimittajaan ja "+
               "    kerro\n, millaisessa toiminnassa t&auml;llainen virhe\n"+
               "    syntyi. Ohjelman toimittaja: \n"+toimittaja+"\n"+
               "  </p>\n";

    palaute+="  <p>\n"+
             "    Voit palata takaisin selaimen back-napista, \n"+
             "    tai voit palata "+Html.linkki("etusivulle.","Etusivu")+
             "  </p>\n"+Html.lopetus();     

    return palaute;
  }
} 
